//
#include "DefinitionSystem.h"
//
#if defined(DISPATCHER_MOTORSTEPPER)
//
#ifndef DispatcherMotorStepper_h
#define DispatcherMotorStepper_h
//
#include "Command.h"
#include "Dispatcher.h"
#include "Led.h"
// //
// //----------------------------------------------------------------
// // Dispatcher - MotorStepper - SHORT
// //----------------------------------------------------------------
#define SHORT_GST   "GST"
#define SHORT_SST   "SST"
#define SHORT_GSR   "GSR"
#define SHORT_SSR   "SSR"
#define SHORT_GSW   "GSW"
#define SHORT_SSW   "SSW"
#define SHORT_MVS   "MVS"
#define SHORT_WTS   "WTS"
#define SHORT_MWS   "MWS"
//
//----------------------------------------------------------------
// Dispatcher - MotorStepper - MASK
//----------------------------------------------------------------
#define HELP_COMMAND_MOTORSTEPPER    " Help (MotorStepper):"
#define MASK_GST                " %-3s                 : Get Step {stp}"
#define MASK_SST                " %-3s <s>             : Set Step <s>{stp}"
#define MASK_GSR                " %-3s                 : Get Step Range {stp}"
#define MASK_SSR                " %-3s <sl> <sh> <ds>  : Set Step Range <sl><sh><ds>{stp}"
#define MASK_GSW                " %-3s                 : Get Step Wait{ms}"
#define MASK_SSW                " %-3s <w>             : Set Step Wait <w>{ms}"
#define MASK_MVS                " %-3s <s>             : Move Step <s>{stp}"
#define MASK_WTS                " %-3s <w>             : Wait Step <w>{ms}"
#define MASK_MWS                " %-3s <s> <wt>        : Move Wait Step <s><w>"
//
//----------------------------------------------------------------
// Dispatcher - LedSystem
//----------------------------------------------------------------
class CDispatcherMotorStepper : public CDispatcher
{
  protected:
  //
  public:
  CDispatcherMotorStepper(void);
  //
  bool ExecuteGetStep(char* command, int parametercount, char** parameters);
  bool ExecuteSetStep(char* command, int parametercount, char** parameters);
  bool ExecuteGetStepRange(char* command, int parametercount, char** parameters);
  bool ExecuteSetStepRange(char* command, int parametercount, char** parameters);
  bool ExecuteGetStepWait(char* command, int parametercount, char** parameters);
  bool ExecuteSetStepWait(char* command, int parametercount, char** parameters);
  bool ExecuteMoveStep(char* command, int parametercount, char** parameters);
  bool ExecuteWaitStep(char* command, int parametercount, char** parameters);
  bool ExecuteMoveWaitStep(char* command, int parametercount, char** parameters);
  //
  bool virtual HandleInterface(char* command, int parametercount, char** parameters);
  bool Execute(void);
};
//
#endif // DispatcherMotorStepper_h
//
#endif // DISPATCHER_MOTORSTEPPER
//
